using System;
using System.Net;
using System.Net.Sockets;

namespace Dobon.Net.Chat
{
	#region fQ[g
	//Cxg郁\bh\fQ[g
	public delegate void ReceivedMessageEventHandler(object sender, ReceivedMessageEventArgs e);
	public delegate void MemberEventHandler(object sender, MemberEventArgs e);
	public delegate void MembersListEventHandler(object sender, MembersListEventArgs e);
	public delegate void ReceivedErrorEventHandler(object sender, ReceivedErrorEventArgs e);
	#endregion

	#region 񋓌^
	/// <summary>
	/// `bgւ̎Q
	/// </summary>
	public enum LoginState
	{
		/// <summary>
		/// QvĂ
		/// </summary>
		WaitJoin,
		/// <summary>
		/// QĂ
		/// </summary>
		Joined,
		/// <summary>
		/// ގvĂ
		/// </summary>
		WaitPart,
		/// <summary>
		/// ގĂ
		/// </summary>
		Parted
	}
	#endregion

	/// <summary>
	/// Dobon Chat Client̋@\񋟂
	/// </summary>
	public class DobonChatClient : TcpChatClient
	{
		#region Cxg
		/// <summary>
		/// bZ[W󂯎
		/// </summary>
		public event ReceivedMessageEventHandler ReceivedMessage;
		private void OnReceivedMessage(ReceivedMessageEventArgs e)
		{
			if (this.ReceivedMessage != null)
			{
				this.ReceivedMessage(this, e);
			}
		}

		/// <summary>
		/// G[󂯎
		/// </summary>
		public event ReceivedErrorEventHandler ReceivedError;
		private void OnReceivedError(ReceivedErrorEventArgs e)
		{
			//Qvs
			if (this.LoginState == LoginState.WaitJoin)
			{
				this._loginState = LoginState.Parted;
			}

			if (this.ReceivedError != null)
			{
				this.ReceivedError(this, e);
			}
		}

		/// <summary>
		/// o[Q
		/// </summary>
		public event MemberEventHandler JoinedMember;
		private void OnJoinedMember(MemberEventArgs e)
		{
			//͎̎QԂ
			if (this._name == e.Name)
			{
				this._loginState = LoginState.Joined;
			}

			if (this.JoinedMember != null)
			{
				this.JoinedMember(this, e);
			}
		}

		/// <summary>
		/// o[ގ
		/// </summary>
		public event MemberEventHandler PartedMember;
		private void OnPartedMember(MemberEventArgs e)
		{
			//̎͑ގԂ
			if (this._name == e.Name)
			{
				this._loginState = LoginState.Parted;
			}

			if (this.PartedMember != null)
			{
				this.PartedMember(this, e);
			}
		}

		/// <summary>
		/// o[XgĂ
		/// </summary>
		public event MembersListEventHandler UpdatedMembers;
		private void OnUpdatedMembers(MembersListEventArgs e)
		{
			if (this.UpdatedMembers != null)
			{
				this.UpdatedMembers(this, e);
			}
		}
		#endregion
		
		#region vpeB
		private LoginState _loginState;
		/// <summary>
		/// OC
		/// </summary>
		public LoginState LoginState
		{
			get
			{
				return this._loginState;
			}
		}

		private string _name = "";
		/// <summary>
		/// o[
		/// </summary>
		public string Name
		{
			get
			{
				return this._name;
			}
		}
		#endregion

		/// <summary>
		/// RXgN^
		/// </summary>
		public DobonChatClient() : base()
		{
			this._loginState = LoginState.Parted;
		}
		public DobonChatClient(Socket soc) : base(soc)
		{
			this._loginState = LoginState.Parted;
		}

		/// <summary>
		/// T[o[ɐڑ
		/// </summary>
		/// <param name="host">T[o[̃zXg</param>
		/// <param name="port">|[gԍ</param>
		/// <param name="nickName">o[</param>
		public void Connect(string host, int port, string nickName)
		{
			if (nickName.Length == 0)
				throw new ApplicationException("Ow肳Ă܂B");
			if (nickName.IndexOf(' ') >= 0)
				throw new ApplicationException("OɃXy[X邱Ƃ͂ł܂B");
			if (nickName.StartsWith("_"))
				throw new ApplicationException("'_'Ŏn܂閼O͕t邱Ƃł܂B");

			//Oۑ
			this._name = nickName;
			//ڑ
			base.Connect(host, port);
		}

		/// <summary>
		/// bZ[W𑗐M
		/// </summary>
		/// <param name="msg">bZ[W</param>
		public override void SendMessage(string msg)
		{
			if (this.LoginState != LoginState.Joined)
				throw new ApplicationException("`bgɎQĂ܂B");

			//CRLF폜
			msg = msg.Replace("\r\n", "");

			this.Send(ClientCommands.Message + " " + msg);
		}

		/// <summary>
		/// vCx[gbZ[W𑗐M
		/// </summary>
		/// <param name="msg">bZ[W</param>
		/// <param name="to">bZ[W𑗂鑊̖O</param>
		public void SendPrivateMessage(string msg, string to)
		{
			if (this.LoginState != LoginState.Joined)
				throw new ApplicationException("`bgɎQĂ܂B");

			//CRLF폜
			msg = msg.Replace("\r\n", "");

			this.Send(ClientCommands.PrivateMessage + " " + to + " " + msg);
		}

		//f[^M
		protected override void OnReceivedData(ReceivedDataEventArgs e)
		{
			base.OnReceivedData(e);

			DobonChatClient client = (DobonChatClient) e.Client;

			//M𕪉
			string[] cmds = e.ReceivedString.Split(new char[] {' '}, 3);

			//R}h߂
			if (ServerCommands.Error == cmds[0])
			{
				//G[R}h
				this.OnReceivedError(new ReceivedErrorEventArgs(cmds[2]));
			}
			else if (ServerCommands.Message == cmds[0])
			{
				//bZ[WR}h
				this.OnReceivedMessage(
					new ReceivedMessageEventArgs(cmds[1], cmds[2]));
			}
			else if (ServerCommands.PrivateMessage == cmds[0])
			{
				//vCx[gbZ[WR}h
				this.OnReceivedMessage(
					new ReceivedMessageEventArgs(cmds[1], cmds[2], true));
			}
			else if (ServerCommands.JoinMember == cmds[0])
			{
				//o[QR}h
				this.OnJoinedMember(new MemberEventArgs(cmds[2]));
			}
			else if (ServerCommands.PartMember == cmds[0])
			{
				//o[ގR}h
				this.OnPartedMember(new MemberEventArgs(cmds[2]));
			}
			else if (ServerCommands.MembersList == cmds[0])
			{
				//o[XgR}h
				this.OnUpdatedMembers(new MembersListEventArgs(cmds[2].Split(' ')));
			}
		}

		protected override void OnConnected(EventArgs e)
		{
			base.OnConnected(e);

			//`bgւ̎Qv
			this._loginState = LoginState.WaitJoin;
			string line = ClientCommands.Login + " " + this._name;
			this.Send(line);
		}

	}
}
