using System;
using System.Net;
using System.Net.Sockets;

namespace Dobon.Net.Chat
{
	/// <summary>
	/// Dobon Chat Server̋@\񋟂
	/// </summary>
	public class DobonChatServer : TcpChatServer
	{
		#region Cxg
		/// <summary>
		/// oOC
		/// </summary>
		public event ServerEventHandler LoggedinMember;
		private void OnLoggedinMember(ServerEventArgs e)
		{
			if (this.LoggedinMember != null)
			{
				this.LoggedinMember(this, e);
			}
		}

		/// <summary>
		/// oOAEg
		/// </summary>
		public event ServerEventHandler LoggedoutMember;
		private void OnLoggedoutMember(ServerEventArgs e)
		{
			if (this.LoggedoutMember != null)
			{
				this.LoggedoutMember(this, e);
			}
		}
		#endregion

		/// <summary>
		/// DobonChatServer̃RXgN^
		/// </summary>
		public DobonChatServer() : base()
		{
		}

		public override void SendMessageToAllClients(string msg)
		{
			//CRLF폜
			msg = msg.Replace("\r\n", "");

			this.SendToAllClients(ServerCommands.Message + " _HOST " + msg);
		}

		/// <summary>
		/// ONCAgT
		/// </summary>
		/// <param name="nickName">TO</param>
		/// <returns>AcceptedChatClientIuWFNg</returns>
		public AcceptedChatClient FindMember(string nickName)
		{
			lock (this._acceptedClients.SyncRoot)
			{
				foreach (AcceptedChatClient c in this._acceptedClients)
				{
					if (c.Name == nickName)
						return c;
				}
			}

			return null;
		}

		//NCAg̃f[^M
		protected override void OnReceivedData(ReceivedDataEventArgs e)
		{
			base.OnReceivedData(e);

			AcceptedChatClient client = (AcceptedChatClient) e.Client;

			//M𕪉
			string[] cmds = e.ReceivedString.Split(new char[] {' '}, 2);

			//R}h𒲂ׂ
			if (ClientCommands.Login == cmds[0])
			{
				//`bgQR}h
				if (client.LoginState != LoginState.Parted)
				{
					this.SendErrorMessage(client, "łɎQĂ܂B");
					return;
				}

				//OK
				string nickName = cmds[1];
				if (nickName.Length == 0 || nickName.IndexOf(' ') >= 0 ||
					nickName.StartsWith("_"))
				{
					this.SendErrorMessage(client, "OsłB");
					return;
				}

				//OȂׂ
				lock (this._acceptedClients.SyncRoot)
				{
					foreach (AcceptedChatClient c in this._acceptedClients)
					{
						if (nickName == c.Name)
						{
							this.SendErrorMessage(client, "Õo[łɃOCĂ܂B");
							return;
						}
					}

					//OAԂ̍XV
					client.Name = nickName;
					client.LoginState = LoginState.Joined;
				}

				//Cxg
				this.OnLoggedinMember(new ServerEventArgs(client));
				//NCAgɒʒm
				this.SendToAllClients(ServerCommands.JoinMember + " _HOST " + client.Name);
				//oXg𑗂
				this.SendMembersList(client);
			}
			else if (ClientCommands.Logout == cmds[0])
			{
				//ގR}h
				if (client.LoginState != LoginState.Joined)
				{
					this.SendErrorMessage(client, "`bgɎQĂ܂B");
					return;
				}
				
				//Ԃ̍XV
				client.LoginState = LoginState.Parted;
				//Cxg
				this.OnLoggedoutMember(new ServerEventArgs(client));
				//NCAgɒʒm
				this.SendToAllClients(ServerCommands.PartMember + " _HOST " + client.Name);
			}
			else if (ClientCommands.MembersList == cmds[0])
			{
				//oXgvR}h
				if (client.LoginState != LoginState.Joined)
				{
					this.SendErrorMessage(client, "`bgɎQĂ܂B");
					return;
				}

				//oXg𑗂
				this.SendMembersList(client);
			}
			else if (ClientCommands.Message == cmds[0])
			{
				//bZ[WMR}h
				if (client.LoginState != LoginState.Joined)
				{
					this.SendErrorMessage(client, "`bgɎQĂ܂B");
					return;
				}

				//NCAgɃbZ[W𑗐M
				this.SendToAllClients(ServerCommands.Message + " " + client.Name + " " + cmds[1]);
			}
			else if (ClientCommands.PrivateMessage == cmds[0])
			{
				//vCx[gbZ[WMR}h
				if (client.LoginState != LoginState.Joined)
				{
					this.SendErrorMessage(client, "`bgɎQĂ܂B");
					return;
				}

				string[] msgs = cmds[1].Split(new char[] {' '}, 2);

				//ONCAgT
				AcceptedChatClient toClient = this.FindMember(msgs[0]);
				if (toClient == null)
				{
					this.SendErrorMessage(client, "M̎Q҂܂B");
					return;
				}

				//NCAgɃbZ[W𑗐M
				toClient.Send(ServerCommands.PrivateMessage + " " + client.Name + " " + msgs[1]);
			}
		}

		//NCAgؒf
		protected override void OnDisconnectedClient(ServerEventArgs e)
		{
			AcceptedChatClient ac = (AcceptedChatClient) e.Client;
			//OCĂƂ́AOoĂ
			string clientName = "";
			if (ac.LoginState == LoginState.Joined)
			{
				clientName = ac.Name;
			}
			
			//{NXOnDisconnectedClient
			base.OnDisconnectedClient(e);

			//õOAEgʒm
			if (clientName.Length > 0)
				this.SendToAllClients(ServerCommands.PartMember + " _HOST " + clientName);
		}

		protected override TcpChatClient CreateChatClient(Socket soc)
		{
			return new AcceptedChatClient(soc);
		}

		/// <summary>
		/// G[bZ[WNCAgɑM
		/// </summary>
		/// <param name="client">M̃NCAg</param>
		/// <param name="msg">bZ[W</param>
		protected override void SendErrorMessage(TcpChatClient client, string msg)
		{
			client.Send(ServerCommands.Error + " _HOST " + msg);
		}

		/// <summary>
		/// oXg𑗐M
		/// </summary>
		private void SendMembersList(TcpChatClient client)
		{
			string msg = "";
			lock (this._acceptedClients.SyncRoot)
			{
				foreach (AcceptedChatClient c in this._acceptedClients)
				{
					msg += c.Name + " ";
				}
			}
			msg = msg.TrimEnd(' ');

			client.Send(ServerCommands.MembersList + " _HOST " + msg);
		}
	}
}
