using System;
using System.Net;
using System.Net.Sockets;

namespace Dobon.Net.Chat
{
	#region fQ[g
	/// <summary>
	/// Mf[^Cxg郁\bh\
	/// </summary>
	public delegate void ReceivedDataEventHandler(object sender, ReceivedDataEventArgs e);
	#endregion

	/// <summary>
	/// TCP`bgNCAg̊{Iȋ@\񋟂
	/// </summary>
	public class TcpChatClient : IDisposable
	{
		#region IDisposable o
		/// <summary>
		/// j
		/// </summary>
		public virtual void Dispose()
		{
			this.Close();
		}
		#endregion

		#region Cxg
		/// <summary>
		/// f[^M
		/// </summary>
		public event ReceivedDataEventHandler ReceivedData;
		protected virtual void OnReceivedData(ReceivedDataEventArgs e)
		{
			if (this.ReceivedData != null)
			{
				this.ReceivedData(this, e);
			}
		}

		/// <summary>
		/// T[o[ɐڑ
		/// </summary>
		public event EventHandler Connected;
		protected virtual void OnConnected(EventArgs e)
		{
			if (this.Connected != null)
			{
				this.Connected(this, e);
			}
		}

		/// <summary>
		/// T[o[ؒfꂽA邢͐ؒf
		/// </summary>
		public event EventHandler Disconnected;
		protected virtual void OnDisconnected(EventArgs e)
		{
			if (this.Disconnected != null)
			{
				this.Disconnected(this, e);
			}
		}
		#endregion

		#region vpeB
		private System.Text.Encoding _encoding;
		/// <summary>
		/// gp镶R[h
		/// </summary>
		protected System.Text.Encoding Encoding
		{
			get
			{
				return this._encoding;
			}
			set
			{
				_encoding = value;
			}
		}

		private Socket _socket;
		/// <summary>
		/// ɂȂSocket
		/// </summary>
		protected Socket Client
		{
			get
			{
				return this._socket;
			}
		}

		private IPEndPoint _localEndPoint;
		/// <summary>
		/// [JGh|Cg
		/// </summary>
		public IPEndPoint LocalEndPoint
		{
			get
			{
				return this._localEndPoint;
			}
		}

		private IPEndPoint _remoteEndPoint;
		/// <summary>
		/// [JGh|Cg
		/// </summary>
		public IPEndPoint RemoteEndPoint
		{
			get
			{
				return this._remoteEndPoint;
			}
		}

		/// <summary>
		/// Ă邩
		/// </summary>
		public bool IsClosed
		{
			get
			{
				return (this._socket == null);
			}
		}

		private int _maxReceiveLength;
		/// <summary>
		/// ŎMłőoCg
		/// </summary>
		protected int MaxReceiveLenght
		{
			get
			{
				return _maxReceiveLength;
			}
			set
			{
				_maxReceiveLength = value;
			}
		}
		#endregion

		#region tB[h
		/// <summary>
		/// Mf[^
		/// </summary>
		protected System.IO.MemoryStream receivedBytes;
		private bool startedReceiving = false;
		#endregion

		/// <summary>
		/// RXgN^
		/// </summary>
		public TcpChatClient()
		{
			this.Initialize();
			
			this._socket = new Socket(AddressFamily.InterNetwork,
				SocketType.Stream, ProtocolType.Tcp);
		}
		public TcpChatClient(Socket soc)
		{
			this.Initialize();
			
			this._socket = soc;
			this._localEndPoint = (IPEndPoint) soc.LocalEndPoint;
			this._remoteEndPoint = (IPEndPoint) soc.RemoteEndPoint;
		}

		private void Initialize()
		{
			this.Encoding = System.Text.Encoding.UTF8;
			this.MaxReceiveLenght = int.MaxValue;
		}

		/// <summary>
		/// T[o[ɐڑ
		/// </summary>
		/// <param name="host">zXg</param>
		/// <param name="port">|[gԍ</param>
		public void Connect(string host, int port)
		{
			if (this.IsClosed)
				throw new ApplicationException("Ă܂B");
			if (this._socket.Connected)
				throw new ApplicationException("łɐڑĂ܂B");

			//ڑ
			IPEndPoint ipEnd = new IPEndPoint(
				Dns.Resolve(host).AddressList[0], port);
			this._socket.Connect(ipEnd);

			this._localEndPoint = (IPEndPoint) this._socket.LocalEndPoint;
			this._remoteEndPoint = (IPEndPoint) this._socket.RemoteEndPoint;

			//Cxg𔭐
			this.OnConnected(new EventArgs());

			//񓯊f[^MJn
			this.StartReceive();
		}

		/// <summary>
		/// ؒf
		/// </summary>
		public void Close()
		{
			lock (this)
			{
				if (this.IsClosed)
					return;

				//
				this._socket.Shutdown(SocketShutdown.Both);
				this._socket.Close();
				this._socket = null;
				if (this.receivedBytes != null)
				{
					this.receivedBytes.Close();
					this.receivedBytes = null;
				}
			}
			//Cxg𔭐
			this.OnDisconnected(new EventArgs());
		}

		/// <summary>
		/// 𑗐M
		/// </summary>
		/// <param name="str">M镶</param>
		public void Send(string str)
		{
			if (this.IsClosed)
				throw new ApplicationException("Ă܂B");

			//Byte^zɕϊ
			byte[] sendBytes = this.Encoding.GetBytes(str + "\r\n");

			lock (this)
			{
				//f[^𑗐M
				this._socket.Send(sendBytes);
			}
		}

		/// <summary>
		/// bZ[W𑗐M
		/// </summary>
		/// <param name="msg">M郁bZ[W</param>
		public virtual void SendMessage(string msg)
		{
			//CRLF폜
			msg = msg.Replace("\r\n", "");

			this.Send(msg);
		}

		/// <summary>
		/// f[^̔񓯊MJn
		/// </summary>
		public void StartReceive()
		{
			if (this.IsClosed)
				throw new ApplicationException("Ă܂B");
			if (this.startedReceiving)
				throw new ApplicationException("StartReceivełɌĂяoĂ܂B");

			//
			byte[] receiveBuffer = new byte[1024];
			this.receivedBytes = new System.IO.MemoryStream();
			this.startedReceiving = true;

			//񓯊MJn
			this._socket.BeginReceive(receiveBuffer,
				0, receiveBuffer.Length,
				SocketFlags.None, new AsyncCallback(ReceiveDataCallback),
				receiveBuffer);
		}

		//BeginReceivẽR[obN
		private void ReceiveDataCallback(IAsyncResult ar)
		{
			int len = -1;
			//ǂݍ񂾒擾
			try
			{
				lock (this)
				{
					len = this._socket.EndReceive(ar);
				}
			}
			catch
			{
			}
			//ؒfꂽׂ
			if (len <= 0)
			{
				this.Close();
				return;
			}

			//Mf[^擾
			byte[] receiveBuffer = (byte[]) ar.AsyncState;

			//Mf[^~ς
			this.receivedBytes.Write(receiveBuffer, 0, len);
			//ől𒴂́Aڑ
			if (this.receivedBytes.Length > this.MaxReceiveLenght)
			{
				this.Close();
				return;
			}
			//Ō܂ŎMׂ
			if (this.receivedBytes.Length >= 2)
			{
				this.receivedBytes.Seek(-2, System.IO.SeekOrigin.End);
				if (this.receivedBytes.ReadByte() == (int) '\r' &&
					this.receivedBytes.ReadByte() == (int) '\n')
				{
					//Ō܂ŎM
					//Mf[^𕶎ɕϊ
					string str = this.Encoding.GetString(
						this.receivedBytes.ToArray());
					this.receivedBytes.Close();
					//sɕ
					int startPos = 0, endPos;
					while ((endPos = str.IndexOf("\r\n", startPos)) >=0 )
					{
						string line = str.Substring(startPos, endPos - startPos);
						startPos = endPos + 2;
						//Cxg𔭐
						this.OnReceivedData(new ReceivedDataEventArgs(this, line));
					}
					this.receivedBytes = new System.IO.MemoryStream();
				}
				else
				{
					this.receivedBytes.Seek(0, System.IO.SeekOrigin.End);
				}
			}

			lock (this)
			{
				//ĂюMJn
				this._socket.BeginReceive(receiveBuffer,
					0, receiveBuffer.Length,
					SocketFlags.None, new AsyncCallback(ReceiveDataCallback)
					, receiveBuffer);
			}
		}
	}
}
