using System;
using System.Net;
using System.Net.Sockets;

namespace Dobon.Net.Chat
{
	#region fQ[g
	/// <summary>
	/// NCAgCxg郁\bh\
	/// </summary>
	public delegate void ServerEventHandler(object sender, ServerEventArgs e);
	#endregion

	#region 񋓌^
	/// <summary>
	/// T[o[̏
	/// </summary>
	public enum ServerState
	{
		None,
		Listening,
		Stopped
	}
	#endregion

	/// <summary>
	/// TCP`bgT[o[̊{Iȋ@\񋟂
	/// </summary>
	public class TcpChatServer : IDisposable
	{
		#region IDisposable o
		/// <summary>
		/// j
		/// </summary>
		public virtual void Dispose()
		{
			this.Close();
		}
		#endregion

		#region Cxg
		/// <summary>
		/// NCAg󂯓ꂽ
		/// </summary>
		public event ServerEventHandler AcceptedClient;
		protected virtual void OnAcceptedClient(ServerEventArgs e)
		{
			if (this.AcceptedClient != null)
			{
				this.AcceptedClient(this, e);
			}
		}

		/// <summary>
		/// NCAgf[^M
		/// </summary>
		public event ReceivedDataEventHandler ReceivedData;
		protected virtual void OnReceivedData(ReceivedDataEventArgs e)
		{
			if (this.ReceivedData != null)
			{
				this.ReceivedData(this, e);
			}
		}

		/// <summary>
		/// NCAgؒf
		/// </summary>
		public event ServerEventHandler DisconnectedClient;
		protected virtual void OnDisconnectedClient(ServerEventArgs e)
		{
			if (this.DisconnectedClient != null)
			{
				this.DisconnectedClient(this, e);
			}
		}
		#endregion

		#region vpeB
		private Socket _server;
		/// <summary>
		/// ɂȂSocket
		/// </summary>
		protected Socket Server
		{
			get
			{
				return this._server;
			}
		}

		protected ServerState _serverState;
		/// <summary>
		/// 
		/// </summary>
		public ServerState ServerState
		{
			get
			{
				return this._serverState;
			}
		}

		private IPEndPoint _socketEP;
		/// <summary>
		/// [JGh|Cg
		/// </summary>
		public IPEndPoint LocalEndPoint
		{
			get
			{
				return this._socketEP;
			}
		}

		protected System.Collections.ArrayList _acceptedClients;
		/// <summary>
		/// ڑ̃NCAg
		/// </summary>
		public virtual TcpChatClient[] AcceptedClients
		{
			get
			{
				return (TcpChatClient[]) this._acceptedClients.ToArray(typeof(TcpChatClient));
			}
		}

		private int _maxClients;
		/// <summary>
		/// ڑNCAg
		/// </summary>
		public int MaxClients
		{
			get
			{
				return this._maxClients;
			}
			set
			{
				this._maxClients = value;
			}
		}
		#endregion

		#region tB[h
		#endregion

		/// <summary>
		/// TcpChatServer̃RXgN^
		/// </summary>
		public TcpChatServer()
		{
			this._maxClients = 100;
			this._server = new Socket(AddressFamily.InterNetwork,
				SocketType.Stream, ProtocolType.Tcp);
			this._acceptedClients =
				System.Collections.ArrayList.Synchronized(
				new System.Collections.ArrayList());
		}

		/// <summary>
		/// ListenJn
		/// </summary>
		/// <param name="host">zXg</param>
		/// <param name="portNum">|[gԍ</param>
		public void Listen(string host, int portNum, int backlog)
		{
			if (this._server == null)
				throw new ApplicationException("jĂ܂B");
			if (this.ServerState != ServerState.None)
				throw new ApplicationException("łListenłB");

			this._socketEP = new IPEndPoint(
				Dns.Resolve(host).AddressList[0], portNum);
			this._server.Bind(this._socketEP);
				
			//ListenJn
			this._server.Listen(backlog);
			this._serverState = ServerState.Listening;

			//ڑv{sJn
			this._server.BeginAccept(new AsyncCallback(this.AcceptCallback), null);
		}
		public void Listen(string host, int portNum)
		{
			this.Listen(host, portNum, 100);
		}

		/// <summary>
		/// ڑׂ̂ẴNCAgɃbZ[W𑗐M
		/// </summary>
		/// <param name="str">M镶</param>
		public virtual void SendMessageToAllClients(string msg)
		{
			//CRLF폜
			msg = msg.Replace("\r\n", "");

			this.SendToAllClients(msg);
		}

		/// <summary>
		/// NCAgɃG[bZ[W𑗐M
		/// </summary>
		/// <param name="client">M̃NCAg</param>
		/// <param name="msg">MG[bZ[W</param>
		protected virtual void SendErrorMessage(TcpChatClient client, string msg)
		{
			client.SendMessage(msg);
		}

		/// <summary>
		/// Ď𒆎~iA͕sj
		/// </summary>
		public void StopListen()
		{
			lock (this)
			{
				if (this._server == null)
					return;
				this._server.Close();
				this._server = null;
				this._serverState = ServerState.Stopped;
			}

		}

		/// <summary>
		/// 
		/// </summary>
		public void Close()
		{
			this.StopListen();
			this.CloseAllClients();
		}

		/// <summary>
		/// ڑ̃NCAg
		/// </summary>
		public void CloseClient(TcpChatClient client)
		{
			this._acceptedClients.Remove(client);
			client.Close();
		}

		/// <summary>
		/// ڑׂ̂ẴNCAg
		/// </summary>
		public void CloseAllClients()
		{
			lock (this._acceptedClients.SyncRoot)
			{
				while (this._acceptedClients.Count > 0)
				{
					this.CloseClient((TcpChatClient) this._acceptedClients[0]);
				}
			}
		}

		/// <summary>
		/// ڑׂ̂ẴNCAgɕ𑗐M
		/// </summary>
		/// <param name="str">M镶</param>
		protected void SendToAllClients(string str)
		{
			lock (this._acceptedClients.SyncRoot)
			{
				for (int i = 0; i < this._acceptedClients.Count; i++)
				{
					((TcpChatClient) this._acceptedClients[i]).Send(str);
				}
			}
		}

		/// <summary>
		/// T[o[ŎgpNCAgNX쐬
		/// </summary>
		/// <param name="soc">ɂȂSocket</param>
		/// <returns>NCAgNX</returns>
		protected virtual TcpChatClient CreateChatClient(Socket soc)
		{
			return new TcpChatClient(soc);
		}

		//BeginAccept̃R[obN
		private void AcceptCallback(IAsyncResult ar)
		{
			//ڑv󂯓
			Socket soc = null;
			try
			{
				lock (this)
				{
					soc = this._server.EndAccept(ar);
				}
			}
			catch
			{
				this.Close();
				return;
			}

			//TcpChatClient̍쐬
			TcpChatClient client = this.CreateChatClient(soc);
			//ő吔𒴂ĂȂ
			if (this._acceptedClients.Count >= this.MaxClients)
			{
				client.Close();
			}
			else
			{
				//RNVɒǉ
				this._acceptedClients.Add(client);
				//Cxgnh̒ǉ
				client.Disconnected += new EventHandler(client_Disconnected);
				client.ReceivedData += new ReceivedDataEventHandler(client_ReceivedData);
				//Cxg𔭐
				this.OnAcceptedClient(new ServerEventArgs(client));
				//f[^MJn
				if (!client.IsClosed)
				{
					client.StartReceive();
				}
			}

			//ڑv{sĊJ
			this._server.BeginAccept(new AsyncCallback(this.AcceptCallback), null);
		}

		#region NCAg̃Cxgnh
		//NCAgؒf
		private void client_Disconnected(object sender, EventArgs e)
		{
			//Xg폜
			this._acceptedClients.Remove((TcpChatClient) sender);
			//Cxg𔭐
			this.OnDisconnectedClient(new ServerEventArgs((TcpChatClient) sender));
		}

		//NCAgf[^M
		private void client_ReceivedData(object sender, ReceivedDataEventArgs e)
		{
			//Cxg𔭐
			this.OnReceivedData(new ReceivedDataEventArgs(
				(TcpChatClient) sender, e.ReceivedString));
		}
		#endregion
	}
}
