Imports System
Imports System.Net
Imports System.Net.Sockets

Namespace Dobon.Net.Chat
    'Cxg郁\bh\fQ[g
    Public Delegate Sub ReceivedMessageEventHandler(ByVal sender As Object, ByVal e As ReceivedMessageEventArgs)
    Public Delegate Sub MemberEventHandler(ByVal sender As Object, ByVal e As MemberEventArgs)
    Public Delegate Sub MembersListEventHandler(ByVal sender As Object, ByVal e As MembersListEventArgs)
    Public Delegate Sub ReceivedErrorEventHandler(ByVal sender As Object, ByVal e As ReceivedErrorEventArgs)

    ''' <summary>
    ''' `bgւ̎Q
    ''' </summary>
    Public Enum LoginState
        ''' <summary>
        ''' QvĂ
        ''' </summary>
        WaitJoin
        ''' <summary>
        ''' QĂ
        ''' </summary>
        Joined
        ''' <summary>
        ''' ގvĂ
        ''' </summary>
        WaitPart
        ''' <summary>
        ''' ގĂ
        ''' </summary>
        Parted
    End Enum

    ''' <summary>
    ''' Dobon Chat Client̋@\񋟂
    ''' </summary>
    Public Class DobonChatClient
        Inherits TcpChatClient

        ''' <summary>
        ''' bZ[W󂯎
        ''' </summary>
        Public Event ReceivedMessage As ReceivedMessageEventHandler
        Private Sub OnReceivedMessage(ByVal e As ReceivedMessageEventArgs)
            RaiseEvent ReceivedMessage(Me, e)
        End Sub

        ''' <summary>
        ''' G[󂯎
        ''' </summary>
        Public Event ReceivedError As ReceivedErrorEventHandler
        Private Sub OnReceivedError(ByVal e As ReceivedErrorEventArgs)
            'Qvs
            If Me.LoginState = LoginState.WaitJoin Then
                Me._loginState = LoginState.Parted
            End If

            RaiseEvent ReceivedError(Me, e)
        End Sub

        ''' <summary>
        ''' o[Q
        ''' </summary>
        Public Event JoinedMember As MemberEventHandler
        Private Sub OnJoinedMember(ByVal e As MemberEventArgs)
            '͎̎QԂ
            If Me._name = e.Name Then
                Me._loginState = LoginState.Joined
            End If

            RaiseEvent JoinedMember(Me, e)
        End Sub

        ''' <summary>
        ''' o[ގ
        ''' </summary>
        Public Event PartedMember As MemberEventHandler
        Private Sub OnPartedMember(ByVal e As MemberEventArgs)
            '̎͑ގԂ
            If Me._name = e.Name Then
                Me._loginState = LoginState.Parted
            End If

            RaiseEvent PartedMember(Me, e)
        End Sub

        ''' <summary>
        ''' o[XgĂ
        ''' </summary>
        Public Event UpdatedMembers As MembersListEventHandler
        Private Sub OnUpdatedMembers(ByVal e As MembersListEventArgs)
            RaiseEvent UpdatedMembers(Me, e)
        End Sub

        Private _loginState As LoginState
        ''' <summary>
        ''' OC
        ''' </summary>
        Public ReadOnly Property LoginState() As LoginState
            Get
                Return Me._loginState
            End Get
        End Property

        Private _name As String = ""
        ''' <summary>
        ''' o[
        ''' </summary>
        Public ReadOnly Property Name() As String
            Get
                Return Me._name
            End Get
        End Property

        ''' <summary>
        ''' RXgN^
        ''' </summary>
        Public Sub New()
            MyBase.New()
            Me._loginState = LoginState.Parted
        End Sub

        Public Sub New(ByVal soc As Socket)
            MyBase.New(soc)
            Me._loginState = LoginState.Parted
        End Sub

        ''' <summary>
        ''' T[o[ɐڑ
        ''' </summary>
        ''' <param name="host">T[o[̃zXg</param>
        ''' <param name="port">|[gԍ</param>
        ''' <param name="nickName">o[</param>
        Public Overloads Sub Connect(ByVal host As String, ByVal port As Integer, ByVal nickName As String)
            If nickName.Length = 0 Then
                Throw New ApplicationException("Ow肳Ă܂B")
            End If
            If nickName.IndexOf(" "c) >= 0 Then
                Throw New ApplicationException("OɃXy[X邱Ƃ͂ł܂B")
            End If
            If nickName.StartsWith("_") Then
                Throw New ApplicationException("'_'Ŏn܂閼O͕t邱Ƃł܂B")
            End If

            'Oۑ
            Me._name = nickName
            'ڑ
            MyBase.Connect(host, port)
        End Sub

        ''' <summary>
        ''' bZ[W𑗐M
        ''' </summary>
        ''' <param name="msg">bZ[W</param>
        Public Overrides Sub SendMessage(ByVal msg As String)
            If Me.LoginState <> LoginState.Joined Then
                Throw New ApplicationException("`bgɎQĂ܂B")
            End If

            'CRLF폜
            msg = msg.Replace(vbCrLf, "")

            Me.Send((ClientCommands.Message + " " + msg))
        End Sub

        ''' <summary>
        ''' vCx[gbZ[W𑗐M
        ''' </summary>
        ''' <param name="msg">bZ[W</param>
        ''' <param name="to">bZ[W𑗂鑊̖O</param>
        Public Sub SendPrivateMessage(ByVal msg As String, ByVal [to] As String)
            If Me.LoginState <> LoginState.Joined Then
                Throw New ApplicationException("`bgɎQĂ܂B")
            End If

            'CRLF폜
            msg = msg.Replace(vbCrLf, "")

            Me.Send((ClientCommands.PrivateMessage + " " + [to] + " " + msg))
        End Sub

        'f[^M
        Protected Overrides Sub OnReceivedData(ByVal e As ReceivedDataEventArgs)
            MyBase.OnReceivedData(e)

            Dim client As DobonChatClient = CType(e.Client, DobonChatClient)

            'M𕪉
            Dim cmds As String() = e.ReceivedString.Split(New Char() {" "c}, 3)

            'R}h߂
            If ServerCommands.Error = cmds(0) Then
                'G[R}h
                Me.OnReceivedError(New ReceivedErrorEventArgs(cmds(2)))
            ElseIf ServerCommands.Message = cmds(0) Then
                'bZ[WR}h
                Me.OnReceivedMessage(New ReceivedMessageEventArgs(cmds(1), cmds(2)))
            ElseIf ServerCommands.PrivateMessage = cmds(0) Then
                'vCx[gbZ[WR}h
                Me.OnReceivedMessage(New ReceivedMessageEventArgs(cmds(1), cmds(2), True))
            ElseIf ServerCommands.JoinMember = cmds(0) Then
                'o[QR}h
                Me.OnJoinedMember(New MemberEventArgs(cmds(2)))
            ElseIf ServerCommands.PartMember = cmds(0) Then
                'o[ގR}h
                Me.OnPartedMember(New MemberEventArgs(cmds(2)))
            ElseIf ServerCommands.MembersList = cmds(0) Then
                'o[XgR}h
                Me.OnUpdatedMembers(New MembersListEventArgs(cmds(2).Split(" "c)))
            End If
        End Sub

        Protected Overrides Sub OnConnected(ByVal e As EventArgs)
            MyBase.OnConnected(e)

            '`bgւ̎Qv
            Me._loginState = LoginState.WaitJoin
            Dim line As String = ClientCommands.Login + " " + Me._name
            Me.Send(line)
        End Sub
    End Class
End Namespace