Imports System
Imports System.Net
Imports System.Net.Sockets

Namespace Dobon.Net.Chat
    ''' <summary>
    ''' Dobon Chat Server̋@\񋟂
    ''' </summary>
    Public Class DobonChatServer
        Inherits TcpChatServer

        ''' <summary>
        ''' oOC
        ''' </summary>
        Public Event LoggedinMember As ServerEventHandler
        Private Sub OnLoggedinMember(ByVal e As ServerEventArgs)
            RaiseEvent LoggedinMember(Me, e)
        End Sub

        ''' <summary>
        ''' oOAEg
        ''' </summary>
        Public Event LoggedoutMember As ServerEventHandler
        Private Sub OnLoggedoutMember(ByVal e As ServerEventArgs)
            RaiseEvent LoggedoutMember(Me, e)
        End Sub

        ''' <summary>
        ''' DobonChatServer̃RXgN^
        ''' </summary>
        Public Sub New()
            MyBase.New()
        End Sub

        Public Overrides Sub SendMessageToAllClients(ByVal msg As String)
            'CRLF폜
            msg = msg.Replace(vbCrLf, "")

            Me.SendToAllClients((ServerCommands.Message + " _HOST " + msg))
        End Sub

        ''' <summary>
        ''' ONCAgT
        ''' </summary>
        ''' <param name="nickName">TO</param>
        ''' <returns>AcceptedChatClientIuWFNg</returns>
        Public Function FindMember(ByVal nickName As String) As AcceptedChatClient
            SyncLock Me._acceptedClients.SyncRoot
                Dim c As AcceptedChatClient
                For Each c In Me._acceptedClients
                    If c.Name = nickName Then
                        Return c
                    End If
                Next c
            End SyncLock
            Return Nothing
        End Function

        'NCAg̃f[^M
        Protected Overrides Sub OnReceivedData(ByVal e As ReceivedDataEventArgs)
            MyBase.OnReceivedData(e)

            Dim client As AcceptedChatClient = CType(e.Client, AcceptedChatClient)

            'M𕪉
            Dim cmds As String() = e.ReceivedString.Split(New Char() {" "c}, 2)

            'R}h𒲂ׂ
            If ClientCommands.Login = cmds(0) Then
                '`bgQR}h
                If client.LoginState <> LoginState.Parted Then
                    Me.SendErrorMessage(client, "łɎQĂ܂B")
                    Return
                End If

                'OK
                Dim nickName As String = cmds(1)
                If nickName.Length = 0 Or nickName.IndexOf(" "c) >= 0 Or nickName.StartsWith("_") Then
                    Me.SendErrorMessage(client, "OsłB")
                    Return
                End If

                'OȂׂ
                SyncLock Me._acceptedClients.SyncRoot
                    Dim c As AcceptedChatClient
                    For Each c In Me._acceptedClients
                        If nickName = c.Name Then
                            Me.SendErrorMessage(client, "Õo[łɃOCĂ܂B")
                            Return
                        End If
                    Next c

                    'OAԂ̍XV
                    client.Name = nickName
                    client.LoginState = LoginState.Joined
                End SyncLock

                'Cxg
                Me.OnLoggedinMember(New ServerEventArgs(client))
                'NCAgɒʒm
                Me.SendToAllClients((ServerCommands.JoinMember + " _HOST " + client.Name))
                'oXg𑗂
                Me.SendMembersList(client)
            ElseIf ClientCommands.Logout = cmds(0) Then
                'ގR}h
                If client.LoginState <> LoginState.Joined Then
                    Me.SendErrorMessage(client, "`bgɎQĂ܂B")
                    Return
                End If

                'Ԃ̍XV
                client.LoginState = LoginState.Parted
                'Cxg
                Me.OnLoggedoutMember(New ServerEventArgs(client))
                'NCAgɒʒm
                Me.SendToAllClients((ServerCommands.PartMember + " _HOST " + client.Name))
            ElseIf ClientCommands.MembersList = cmds(0) Then
                'oXgvR}h
                If client.LoginState <> LoginState.Joined Then
                    Me.SendErrorMessage(client, "`bgɎQĂ܂B")
                    Return
                End If

                'oXg𑗂
                Me.SendMembersList(client)
            ElseIf ClientCommands.Message = cmds(0) Then
                'bZ[WMR}h
                If client.LoginState <> LoginState.Joined Then
                    Me.SendErrorMessage(client, "`bgɎQĂ܂B")
                    Return
                End If

                'NCAgɃbZ[W𑗐M
                Me.SendToAllClients((ServerCommands.Message + " " + client.Name + " " + cmds(1)))
            ElseIf ClientCommands.PrivateMessage = cmds(0) Then
                'vCx[gbZ[WMR}h
                If client.LoginState <> LoginState.Joined Then
                    Me.SendErrorMessage(client, "`bgɎQĂ܂B")
                    Return
                End If

                Dim msgs As String() = cmds(1).Split(New Char() {" "c}, 2)

                'ONCAgT
                Dim toClient As AcceptedChatClient = Me.FindMember(msgs(0))
                If toClient Is Nothing Then
                    Me.SendErrorMessage(client, "M̎Q҂܂B")
                    Return
                End If

                'NCAgɃbZ[W𑗐M
                toClient.Send((ServerCommands.PrivateMessage + " " + client.Name + " " + msgs(1)))
            End If
        End Sub

        'NCAgؒf
        Protected Overrides Sub OnDisconnectedClient(ByVal e As ServerEventArgs)
            Dim ac As AcceptedChatClient = CType(e.Client, AcceptedChatClient)
            'OCĂƂ́AOoĂ
            Dim clientName As String = ""
            If ac.LoginState = LoginState.Joined Then
                clientName = ac.Name
            End If

            '{NXOnDisconnectedClient
            MyBase.OnDisconnectedClient(e)

            'õOAEgʒm
            If clientName.Length > 0 Then
                Me.SendToAllClients((ServerCommands.PartMember + " _HOST " + clientName))
            End If
        End Sub

        Protected Overrides Function CreateChatClient(ByVal soc As Socket) As TcpChatClient
            Return New AcceptedChatClient(soc)
        End Function

        ''' <summary>
        ''' G[bZ[WNCAgɑM
        ''' </summary>
        ''' <param name="client">M̃NCAg</param>
        ''' <param name="msg">bZ[W</param>
        Protected Overrides Sub SendErrorMessage(ByVal client As TcpChatClient, ByVal msg As String)
            client.Send((ServerCommands.Error + " _HOST " + msg))
        End Sub

        ''' <summary>
        ''' oXg𑗐M
        ''' </summary>
        Private Sub SendMembersList(ByVal client As TcpChatClient)
            Dim msg As String = ""
            SyncLock Me._acceptedClients.SyncRoot
                Dim c As AcceptedChatClient
                For Each c In Me._acceptedClients
                    msg += c.Name + " "
                Next c
            End SyncLock
            msg = msg.TrimEnd(" "c)

            client.Send((ServerCommands.MembersList + " _HOST " + msg))
        End Sub
    End Class
End Namespace