Imports System
Imports System.Net
Imports System.Net.Sockets

Namespace Dobon.Net.Chat
    ''' <summary>
    ''' Mf[^Cxg郁\bh\
    ''' </summary>
    Public Delegate Sub ReceivedDataEventHandler(ByVal sender As Object, ByVal e As ReceivedDataEventArgs)

    ''' <summary>
    ''' TCP`bgNCAg̊{Iȋ@\񋟂
    ''' </summary>
    Public Class TcpChatClient
        Implements IDisposable

        ''' <summary>
        ''' j
        ''' </summary>
        Public Overridable Sub Dispose() Implements IDisposable.Dispose
            Me.Close()
        End Sub

        ''' <summary>
        ''' f[^M
        ''' </summary>
        Public Event ReceivedData As ReceivedDataEventHandler
        Protected Overridable Sub OnReceivedData(ByVal e As ReceivedDataEventArgs)
            RaiseEvent ReceivedData(Me, e)
        End Sub

        ''' <summary>
        ''' T[o[ɐڑ
        ''' </summary>
        Public Event Connected As EventHandler
        Protected Overridable Sub OnConnected(ByVal e As EventArgs)
            RaiseEvent Connected(Me, e)
        End Sub

        ''' <summary>
        ''' T[o[ؒfꂽA邢͐ؒf
        ''' </summary>
        Public Event Disconnected As EventHandler
        Protected Overridable Sub OnDisconnected(ByVal e As EventArgs)
            RaiseEvent Disconnected(Me, e)
        End Sub

        Private _encoding As System.Text.Encoding
        ''' <summary>
        ''' gp镶R[h
        ''' </summary>
        Protected Property Encoding() As System.Text.Encoding
            Get
                Return Me._encoding
            End Get
            Set(ByVal Value As System.Text.Encoding)
                Me._encoding = Value
            End Set
        End Property

        Private _socket As Socket
        ''' <summary>
        ''' ɂȂSocket
        ''' </summary>
        Protected ReadOnly Property Client() As Socket
            Get
                Return Me._socket
            End Get
        End Property

        Private _localEndPoint As IPEndPoint
        ''' <summary>
        ''' [JGh|Cg
        ''' </summary>
        Public ReadOnly Property LocalEndPoint() As IPEndPoint
            Get
                Return Me._localEndPoint
            End Get
        End Property

        Private _remoteEndPoint As IPEndPoint
        ''' <summary>
        ''' [JGh|Cg
        ''' </summary>
        Public ReadOnly Property RemoteEndPoint() As IPEndPoint
            Get
                Return Me._remoteEndPoint
            End Get
        End Property

        ''' <summary>
        ''' Ă邩
        ''' </summary>
        Public ReadOnly Property IsClosed() As Boolean
            Get
                Return Me._socket Is Nothing
            End Get
        End Property

        Private _maxReceiveLength As Integer
        ''' <summary>
        ''' ŎMłőoCg
        ''' </summary>
        Protected Property MaxReceiveLenght() As Integer
            Get
                Return _maxReceiveLength
            End Get
            Set(ByVal Value As Integer)
                _maxReceiveLength = Value
            End Set
        End Property

        ''' <summary>
        ''' Mf[^
        ''' </summary>
        Protected receivedBytes As System.IO.MemoryStream

        ''' <summary>
        ''' RXgN^
        ''' </summary>
        Public Sub New()
            Me.Initialize()

            Me._socket = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
        End Sub
        Public Sub New(ByVal soc As Socket)
            Me.Initialize()

            Me._socket = soc
            Me._localEndPoint = CType(soc.LocalEndPoint, IPEndPoint)
            Me._remoteEndPoint = CType(soc.RemoteEndPoint, IPEndPoint)
        End Sub

        Private Sub Initialize()
            Me.Encoding = System.Text.Encoding.UTF8
            Me.MaxReceiveLenght = Integer.MaxValue
        End Sub

        ''' <summary>
        ''' T[o[ɐڑ
        ''' </summary>
        ''' <param name="host">zXg</param>
        ''' <param name="port">|[gԍ</param>
        Public Sub Connect(ByVal host As String, ByVal port As Integer)
            If Me.IsClosed Then
                Throw New ApplicationException("Ă܂B")
            End If

            If Me._socket.Connected Then
                Throw New ApplicationException("łɐڑĂ܂B")
            End If

            'ڑ
            Dim ipEnd As New IPEndPoint(Dns.Resolve(host).AddressList(0), port)
            Me._socket.Connect(ipEnd)

            Me._localEndPoint = CType(Me._socket.LocalEndPoint, IPEndPoint)
            Me._remoteEndPoint = CType(Me._socket.RemoteEndPoint, IPEndPoint)

            'Cxg𔭐
            Me.OnConnected(New EventArgs)

            '񓯊f[^MJn
            Me.StartReceive()
        End Sub

        ''' <summary>
        ''' ؒf
        ''' </summary>
        Public Sub Close()
            SyncLock Me
                If (Me.IsClosed) Then
                    Return
                End If

                '
                Me._socket.Shutdown(SocketShutdown.Both)
                Me._socket.Close()
                Me._socket = Nothing
                If Not (Me.receivedBytes Is Nothing) Then
                    Me.receivedBytes.Close()
                    Me.receivedBytes = Nothing
                End If
            End SyncLock
            'Cxg𔭐
            Me.OnDisconnected(New EventArgs)
        End Sub

        ''' <summary>
        ''' 𑗐M
        ''' </summary>
        ''' <param name="str">M镶</param>
        Public Sub Send(ByVal str As String)
            If Me.IsClosed Then
                Throw New ApplicationException("Ă܂B")
            End If

            'Byte^zɕϊ
            Dim sendBytes As Byte() = Me.Encoding.GetBytes((str + vbCrLf))

            SyncLock Me
                'f[^𑗐M
                Me._socket.Send(sendBytes)
            End SyncLock
        End Sub

        ''' <summary>
        ''' bZ[W𑗐M
        ''' </summary>
        ''' <param name="msg">M郁bZ[W</param>
        Public Overridable Sub SendMessage(ByVal msg As String)
            'CRLF폜
            msg = msg.Replace(vbCrLf, "")

            Me.Send(msg)
        End Sub

        ''' <summary>
        ''' f[^̔񓯊MJn
        ''' </summary>
        Public Sub StartReceive()
            If Me.IsClosed Then
                Throw New ApplicationException("Ă܂B")
            End If
            If Not (Me.receivedBytes Is Nothing) Then
                Throw New ApplicationException("StartReceivełɌĂяoĂ܂B")
            End If

            '
            Dim receiveBuffer(1023) As Byte
            Me.receivedBytes = New System.IO.MemoryStream

            '񓯊MJn
            Me._socket.BeginReceive(receiveBuffer, 0, receiveBuffer.Length, _
                SocketFlags.None, _
                New AsyncCallback(AddressOf ReceiveDataCallback), receiveBuffer)
        End Sub

        'BeginReceivẽR[obN
        Private Sub ReceiveDataCallback(ByVal ar As IAsyncResult)
            'ǂݍ񂾒擾
            Dim len As Integer = -1
            Try
                SyncLock Me
                    len = Me._socket.EndReceive(ar)
                End SyncLock
            Catch
                'Socket
            End Try

            'ؒfꂽׂ
            If len <= 0 Then
                Me.Close()
                Return
            End If

            'Mf[^擾
            Dim receiveBuffer As Byte() = CType(ar.AsyncState, Byte())

            'Mf[^~ς
            Me.receivedBytes.Write(receiveBuffer, 0, len)
            'ől𒴂́Aڑ
            If Me.receivedBytes.Length > Me.MaxReceiveLenght Then
                Me.Close()
                Return
            End If
            'Ō܂ŎMׂ
            If Me.receivedBytes.Length >= 2 Then
                Me.receivedBytes.Seek(-2, System.IO.SeekOrigin.End)
                If Me.receivedBytes.ReadByte() = 13 AndAlso _
                    Me.receivedBytes.ReadByte() = 10 Then
                    'Ō܂ŎM
                    'Mf[^𕶎ɕϊ
                    Dim str As String = Me.Encoding.GetString(Me.receivedBytes.ToArray())
                    Me.receivedBytes.Close()
                    'sɕ
                    Dim startPos As Integer = 0
                    Dim endPos As Integer
                    While (True)
                        endPos = str.IndexOf(vbCrLf, startPos)
                        If endPos < 0 Then Exit While
                        Dim line As String = str.Substring(startPos, endPos - startPos)
                        startPos = endPos + 2
                        'Cxg𔭐
                        Me.OnReceivedData(New ReceivedDataEventArgs(Me, line))
                    End While
                    Me.receivedBytes = New System.IO.MemoryStream
                Else
                    Me.receivedBytes.Seek(0, System.IO.SeekOrigin.End)
                End If
            End If

            'ĂюMJn
            SyncLock Me
                Me._socket.BeginReceive(receiveBuffer, 0, receiveBuffer.Length, _
                    SocketFlags.None, _
                    New AsyncCallback(AddressOf ReceiveDataCallback), receiveBuffer)
            End SyncLock
        End Sub
    End Class
End Namespace