Imports System
Imports System.Net
Imports System.Net.Sockets

Namespace Dobon.Net.Chat
    ''' <summary>
    ''' NCAgCxg郁\bh\
    ''' </summary>
    Public Delegate Sub ServerEventHandler(ByVal sender As Object, ByVal e As ServerEventArgs)

    ''' <summary>
    ''' T[o[̏
    ''' </summary>
    Public Enum ServerState
        None
        Listening
        Stopped
    End Enum

    ''' <summary>
    ''' TCP`bgT[o[̊{Iȋ@\񋟂
    ''' </summary>
    Public Class TcpChatServer
        Implements IDisposable

        ''' <summary>
        ''' j
        ''' </summary>
        Public Overridable Sub Dispose() Implements IDisposable.Dispose
            Me.Close()
        End Sub

        ''' <summary>
        ''' NCAg󂯓ꂽ
        ''' </summary>
        Public Event AcceptedClient As ServerEventHandler
        Protected Overridable Sub OnAcceptedClient(ByVal e As ServerEventArgs)
            RaiseEvent AcceptedClient(Me, e)
        End Sub

        ''' <summary>
        ''' NCAgf[^M
        ''' </summary>
        Public Event ReceivedData As ReceivedDataEventHandler
        Protected Overridable Sub OnReceivedData(ByVal e As ReceivedDataEventArgs)
            RaiseEvent ReceivedData(Me, e)
        End Sub

        ''' <summary>
        ''' NCAgؒf
        ''' </summary>
        Public Event DisconnectedClient As ServerEventHandler
        Protected Overridable Sub OnDisconnectedClient(ByVal e As ServerEventArgs)
            RaiseEvent DisconnectedClient(Me, e)
        End Sub

        Private _server As Socket
        ''' <summary>
        ''' ɂȂSocket
        ''' </summary>
        Protected ReadOnly Property Server() As Socket
            Get
                Return Me._server
            End Get
        End Property

        Protected _serverState As ServerState
        ''' <summary>
        ''' 
        ''' </summary>
        Public ReadOnly Property ServerState() As ServerState
            Get
                Return Me._serverState
            End Get
        End Property

        Private _socketEP As IPEndPoint
        ''' <summary>
        ''' [JGh|Cg
        ''' </summary>
        Public ReadOnly Property LocalEndPoint() As IPEndPoint
            Get
                Return Me._socketEP
            End Get
        End Property

        Protected _acceptedClients As System.Collections.ArrayList
        ''' <summary>
        ''' ڑ̃NCAg
        ''' </summary>
        Public Overridable ReadOnly Property AcceptedClients() As TcpChatClient()
            Get
                Return CType(Me._acceptedClients.ToArray(GetType(TcpChatClient)), TcpChatClient())
            End Get
        End Property

        Private _maxClients As Integer
        ''' <summary>
        ''' ڑNCAg
        ''' </summary>
        Public Property MaxClients() As Integer
            Get
                Return Me._maxClients
            End Get
            Set(ByVal Value As Integer)
                Me._maxClients = value
            End Set
        End Property

        ''' <summary>
        ''' TcpChatServer̃RXgN^
        ''' </summary>
        Public Sub New()
            Me.MaxClients = 100
            Me._server = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            Me._acceptedClients = System.Collections.ArrayList.Synchronized(New System.Collections.ArrayList)
        End Sub

        ''' <summary>
        ''' ListenJn
        ''' </summary>
        ''' <param name="host">zXg</param>
        ''' <param name="portNum">|[gԍ</param>
        Public Overloads Sub Listen(ByVal host As String, ByVal portNum As Integer, ByVal backlog As Integer)
            If Me._server Is Nothing Then
                Throw New ApplicationException("jĂ܂B")
            End If
            If Me.ServerState <> ServerState.None Then
                Throw New ApplicationException("łListenłB")
            End If

            Me._socketEP = New IPEndPoint(Dns.Resolve(host).AddressList(0), portNum)
            Me._server.Bind(Me._socketEP)

            'ListenJn
            Me._server.Listen(backlog)
            Me._serverState = ServerState.Listening

            'ڑv{sJn
            Me._server.BeginAccept(New AsyncCallback(AddressOf Me.AcceptCallback), Nothing)
        End Sub

        Public Overloads Sub Listen(ByVal host As String, ByVal portNum As Integer)
            Me.Listen(host, portNum, 100)
        End Sub

        ''' <summary>
        ''' ڑׂ̂ẴNCAgɃbZ[W𑗐M
        ''' </summary>
        ''' <param name="str">M镶</param>
        Public Overridable Sub SendMessageToAllClients(ByVal msg As String)
            'CRLF폜
            msg = msg.Replace(vbCrLf, "")

            Me.SendToAllClients(msg)
        End Sub

        ''' <summary>
        ''' NCAgɃG[bZ[W𑗐M
        ''' </summary>
        ''' <param name="client">M̃NCAg</param>
        ''' <param name="msg">MG[bZ[W</param>
        Protected Overridable Sub SendErrorMessage(ByVal client As TcpChatClient, ByVal msg As String)
            client.SendMessage(msg)
        End Sub

        ''' <summary>
        ''' Ď𒆎~iA͕sj
        ''' </summary>
        Public Sub StopListen()
            SyncLock Me
                If Me._server Is Nothing Then
                    Return
                End If
                Me._server.Close()
                Me._server = Nothing
                Me._serverState = ServerState.Stopped
            End SyncLock
        End Sub

        ''' <summary>
        ''' 
        ''' </summary>
        Public Sub Close()
            Me.StopListen()
            Me.CloseAllClients()
        End Sub

        ''' <summary>
        ''' ڑ̃NCAg
        ''' </summary>
        Public Sub CloseClient(ByVal client As TcpChatClient)
            Me._acceptedClients.Remove(client)
            client.Close()
        End Sub

        ''' <summary>
        ''' ڑׂ̂ẴNCAg
        ''' </summary>
        Public Sub CloseAllClients()
            SyncLock Me._acceptedClients.SyncRoot
                While Me._acceptedClients.Count > 0
                    Me.CloseClient(CType(Me._acceptedClients(0), TcpChatClient))
                End While
            End SyncLock
        End Sub

        ''' <summary>
        ''' ڑׂ̂ẴNCAgɕ𑗐M
        ''' </summary>
        ''' <param name="str">M镶</param>
        Protected Sub SendToAllClients(ByVal str As String)
            SyncLock Me._acceptedClients.SyncRoot
                Dim i As Integer
                For i = 0 To (Me._acceptedClients.Count) - 1
                    CType(Me._acceptedClients(i), TcpChatClient).Send(str)
                Next i
            End SyncLock
        End Sub

        ''' <summary>
        ''' T[o[ŎgpNCAgNX쐬
        ''' </summary>
        ''' <param name="soc">ɂȂSocket</param>
        ''' <returns>NCAgNX</returns>
        Protected Overridable Function CreateChatClient(ByVal soc As Socket) As TcpChatClient
            Return New TcpChatClient(soc)
        End Function

        'BeginAccept̃R[obN
        Private Sub AcceptCallback(ByVal ar As IAsyncResult)
            'ڑv󂯓
            Dim soc As Socket = Nothing
            Try
                SyncLock Me
                    soc = Me._server.EndAccept(ar)
                End SyncLock
            Catch
                Me.Close()
                Return
            End Try

            'TcpChatClient̍쐬
            Dim client As TcpChatClient = Me.CreateChatClient(soc)
            'ő吔𒴂ĂȂ
            If Me._acceptedClients.Count >= Me.MaxClients Then
                client.Close()
            Else
                'RNVɒǉ
                Me._acceptedClients.Add(client)
                'Cxgnh̒ǉ
                AddHandler client.Disconnected, AddressOf client_Disconnected
                AddHandler client.ReceivedData, AddressOf client_ReceivedData
                'Cxg𔭐
                Me.OnAcceptedClient(New ServerEventArgs(client))
                'f[^MJn
                If Not client.IsClosed Then
                    client.StartReceive()
                End If
            End If

            'ڑv{sĊJ
            Me._server.BeginAccept(New AsyncCallback(AddressOf Me.AcceptCallback), Nothing)
        End Sub

        'NCAgؒf
        Private Sub client_Disconnected(ByVal sender As Object, ByVal e As EventArgs) '
            'Xg폜
            Me._acceptedClients.Remove(CType(sender, TcpChatClient))
            'Cxg𔭐
            Me.OnDisconnectedClient(New ServerEventArgs(CType(sender, TcpChatClient)))
        End Sub

        'NCAgf[^M
        Private Sub client_ReceivedData(ByVal sender As Object, ByVal e As ReceivedDataEventArgs)
            'Cxg𔭐
            Me.OnReceivedData(New ReceivedDataEventArgs(CType(sender, TcpChatClient), e.ReceivedString))
        End Sub
    End Class
End Namespace
